<template>
  <el-menu
    :default-active="activeMenu"
    mode="horizontal"
    @select="handleSelect"
  >
    <template v-for="(item, index) in topMenus">
      <!-- <el-menu-item :style="{'--theme': theme}" :index="item.path" :key="index" v-if="index < visibleNumber" -->
      <el-menu-item
        :index="item.path"
        :key="index + `${item.meta.title}`"
        v-if="index < visibleNumber"
        :class="{ isActive: menuAcitve == item.meta.title }"
        @click="menuClick($event, item)"
      >
        <!-- 导航栏左侧图标 -->
        <!-- <svg-icon :icon-class="item.meta.icon" /> -->
        {{ item.meta.title }}
      </el-menu-item>
      <!-- <div class="menu-item-div"></div> -->
    </template>

    <!-- 顶部菜单超出数量折叠 -->
    <!-- <div> -->
    <el-submenu
      class="onlyNavTio moreLise"
      :class="{ noBg: moreMenu }"
      index="more"
      v-if="topMenus.length > visibleNumber"
      ref="noBg"
    >
      <template slot="title">更多菜单</template>
      <template v-for="(item, index) in topMenus">
        <el-menu-item
          class="navTopBar"
          :index="item.path"
          :key="index"
          v-if="index >= visibleNumber"
          @click="menuClick($event, item)"
          ><svg-icon :icon-class="item.meta.icon" />
          {{ item.meta.title }}</el-menu-item
        >
      </template>
    </el-submenu>
    <!-- </div> -->
  </el-menu>
</template>

<script>
import { constantRoutes } from "@/router";

import "../../common/font/font.css";
export default {
  data() {
    return {
      // 顶部栏初始数
      visibleNumber: 5,
      // 是否为首次加载
      isFrist: false,
      // 当前激活菜单的 index
      currentIndex: undefined,
      myRouter: [],
      // 因为更多菜单前面的最后一个总是出问题，所以调整一下
      menuAcitve: null,
      moreMenu: false,
    };
  },

  computed: {
    theme() {
      return this.$store.state.settings.theme;
    },

    // 顶部显示菜单
    topMenus() {
      let topMenus = [];
      this.routers.map((menu) => {
        if (menu.hidden !== true) {
          // 兼容顶部栏一级菜单内部跳转
          if (menu.path === "/") {
            topMenus.push(menu.children[0]);
          } else {
            topMenus.push(menu);
          }
        }
      });
      return topMenus;
    },
    // 所有的路由信息
    routers() {
      return this.$store.state.permission.topbarRouters;
    },
    // 设置子路由
    childrenMenus() {
      var childrenMenus = [];
      this.routers.map((router) => {
        for (var item in router.children) {
          if (router.children[item].parentPath === undefined) {
            if (router.path === "/") {
              router.children[item].path =
                "/redirect/" + router.children[item].path;
            } else {
              if (!this.ishttp(router.children[item].path)) {
                router.children[item].path =
                  router.path + "/" + router.children[item].path;
              }
            }
            router.children[item].parentPath = router.path;
          }
          childrenMenus.push(router.children[item]);
        }
      });
      return constantRoutes.concat(childrenMenus);
    },
    // 默认激活的菜单
    activeMenu() {
      const path = this.$route.path;
      let activePath = this.routers[0].path;
      if (path.lastIndexOf("/") > 0) {
        const tmpPath = path.substring(1, path.length);
        activePath = "/" + tmpPath.substring(0, tmpPath.indexOf("/"));
      } else if ("/index" == path || "" == path) {
        if (!this.isFrist) {
          this.isFrist = true;
        } else {
          activePath = "index";
        }
      }
      var routes = this.activeRoutes(activePath);
      if (routes.length === 0) {
        activePath = this.currentIndex || this.routers[0].path;
        this.activeRoutes(activePath);
      }
      return activePath;
    },
  },
  beforeMount() {
    window.addEventListener("resize", this.setVisibleNumber);
  },
  beforeDestroy() {
    window.removeEventListener("resize", this.setVisibleNumber);
  },
  mounted() {
    this.setVisibleNumber();
    this.moreMenuChange();
  },
  methods: {
    menuClick(e, item) {
      this.menuAcitve = item.meta.title;
      this.moreMenu = false;
    },
    // 为了解决菜单样式bug问题
    moreMenuChange() {
      // 展示更多的前一个路由
      const lastMenuPath = this.topMenus[this.visibleNumber - 1]?.path;
      // 当前跳转的路由
      const routerMenuPath = this.$route.matched[0].path;
      // 如果点击的正好是展示更多的前一个,展示更多就不能拥有高亮
      if (lastMenuPath == routerMenuPath) {
        this.moreMenu = true;
        this.$refs.noBg.$el.addEventListener("mouseover", this.mouseOver);
        this.$refs.noBg.$el.addEventListener("mouseout", this.mouseOut);
      } else {
        this.removeEvt();
      }
      // var reg = new RegExp("(\\s|^)" + 'is-active' + "(\\s|$)");

      // console.log("this.topMenus",this.topMenus[this.visibleNumber-1].path)
      // console.log("this.topMenus",this.$route.matched[0].path)
    },
    mouseOver() {
      this.moreMenu = false;
    },
    mouseOut() {
      this.moreMenu = true;
    },
    removeEvt() {
      if (this.$refs.noBg) {
        this.$refs.noBg.$el.removeEventListener("mouseover", this.mouseOver);
        this.$refs.noBg.$el.removeEventListener("mouseout", this.mouseOut);
      }
    },
    // 根据宽度计算设置显示栏数
    setVisibleNumber() {
      const width = document.body.getBoundingClientRect().width / 3;
      this.visibleNumber = parseInt(width / 88);
    },
    // 菜单选择事件
    handleSelect(key, keyPath) {
      // 点菜单的时候清楚事件，为了解决菜单样式bug问题
      this.removeEvt();

      let path;
      this.currentIndex = key;
      if (this.ishttp(key)) {
        // http(s):// 路径新窗口打开
        window.open(key, "_blank");
      } else if (key.indexOf("/redirect") !== -1) {
        // /redirect 路径内部打开
        this.$router.push({ path: key.replace("/redirect", "") });
      } else {
        // 显示左侧联动菜单
        path = this.activeRoutes(key);
        // console.log("path",this.$store.state.permission.topbarRouters);
        console.log(this.$route.path);

        if (this.$route.path != path[0].path) {
          if (path[0].path) {
            this.$router.push(path[0].path);
          } else {
            if (path[0].path == "" && this.$route.path == "/index") return;
            this.$router.push("/index");
          }
        }
        // 当点击菜单时，如果当前页面是gis地图，就晴空dilog

        // if (key == "/enterprise") {
        //   // this.$store.commit("TOGGLE_DEVICE","mobile");
        //   this.$store.dispatch("app/toggleDevice", "mobile");
        // } else {
        //   this.$store.dispatch("app/toggleDevice", "desktop");
        // }
        // TOGGLE_DEVICE
      }
    },
    // 当前激活的路由
    activeRoutes(key) {
      // if(this.$route.path=="/index") return;
      var routes = [];
      if (this.childrenMenus && this.childrenMenus.length > 0) {
        this.childrenMenus.map((item) => {
          if (key == item.parentPath || (key == "index" && "" == item.path)) {
            routes.push(item);
          }
        });
      }

      // console.log(this.myRouter)

      // console.log(this.myRouter)
      if (routes.length > 0) {
        this.$store.commit("SET_SIDEBAR_ROUTERS", routes);
      }

      return routes;
    },
    ishttp(url) {
      return url.indexOf("http://") !== -1 || url.indexOf("https://") !== -1;
    },
  },
};
</script>

<style lang="scss">
.el-menu--horizontal > .el-menu-item {
  float: left;
  height: 80px;
  text-align: center;
  line-height: 80px;
  margin: 0 20px;
  color: #fff;
  font-size: 22px;
  font-family: "pingfang";
  font-weight: 600;
  text-shadow: 0px 2px 3px rgba(0, 0, 0, 0.2);
  padding: 0 5px;
  border-bottom: none;
  position: relative;
  &:after {
    content: "";
    position: absolute;
    width: 2px;
    height: 38px;
    background: radial-gradient(
      circle,
      #ffffff 0%,
      rgba(255, 255, 255, 0) 100%
    );
    right: -20px;
    top: 21px;
    opacity: 1;
  }
}

// 》〉》〉》导航的样式调整
.navTopBar {
  // background-color: red !important;
  width: 110px !important;
  background-color: #053b6a !important;
  text-align: center !important;
  color: #fff !important;
  &:hover {
    color: #fff !important;
    outline: none;
    background-image: url("../../assets/logo/item-background.png");
    background-repeat: no-repeat;
    background-size: 100% 100%;
    /* background: rgba(0, 0, 0, 0); */
    color: #31eaea !important;
  }
}

.navTopBar:focus,
.navTopBar.is-active,
.isActive {
  outline: none;
  background-image: url("../../assets/logo/item-background.png");
  background-repeat: no-repeat;
  background-size: 100% 100%;
  /* background: rgba(0, 0, 0, 0); */
  color: #31eaea !important;
}
.el-menu--popup {
  z-index: 100;
  min-width: 120px;
  border: none;
  padding: 5px;
  border-radius: 2px;
  -webkit-box-shadow: 0 2px 12px 0 rgb(0 0 0 / 10%);
  box-shadow: 0 2px 12px 0 rgb(0 0 0 / 10%);
  background-color: #053b6a;
}
// 》〉》〉》导航的样式

.el-menu--horizontal > .el-menu-item.is-active {
  border-bottom: 3px solid #{"var(--theme)"};
  /* box-shadow: inset 2px 2px 20px #5CD9D4; */
  color: #5cd9d4;
}

/* submenu item */
.el-menu--horizontal > .el-submenu .el-submenu__title {
  height: 50px !important;
  line-height: 50px !important;
  border: none !important;
  margin-left: 15px;
}
.el-menu--horizontal > .el-menu-item:not(.is-disabled):hover,
.el-menu--horizontal > .el-menu-item:not(.is-disabled):focus {
  background-color: rgba(0, 0, 0, 0);
  /* opacity: 0; */
  /* box-shadow: inset 2px 2px 20px #5CD9D4; */
  color: #fff;
}
.menu-item-div {
  width: 2px;
  height: 30px;
  margin-top: 25px;
  background-color: rgb(190, 189, 189);
  float: left;
  background: linear-gradient(
    130deg,
    rgba(0, 0, 0, 0) 0%,
    rgba(255, 255, 255, 0.7) 50%,
    rgba(0, 0, 0, 0) 100%
  );
}
.submenu-title-noDropdown {
  color: rgb(5 59 106) !important;
  font-weight: 900 !important;
}
.moreLise {
  // background-image: url("../../assets/logo/item-background.png") !important;
  // background-size: 100% 123% !important;
  &.is-active {
    // background-image: url("../../assets/logo/item-background.png") !important;
    background-size: 100% 123% !important;
  }
  .el-submenu__title {
    background-image: none !important;
  }
  &:hover {
    background-image: url("../../assets/logo/item-background.png");
    background-size: 100% 123%;
  }
  // height: 100px;
}
.noBg {
  background: none !important ;
}
</style>
